var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Import Dependencies
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { generateSearchUrlString } from '@ramenjs/utilitybelt';

// Fetch polyfill for IE 11
require('es6-promise').polyfill();
require('isomorphic-fetch');

var FetchContent = function (_Component) {
  _inherits(FetchContent, _Component);

  function FetchContent() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, FetchContent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FetchContent.__proto__ || Object.getPrototypeOf(FetchContent)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isFetching: false,
      hasError: false,
      data: null
    }, _this.getContent = function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(searchData) {
        var _this$props, dataUrl, method, render, body, searchQuery, url, response, data;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$props = _this.props, dataUrl = _this$props.dataUrl, method = _this$props.method, render = _this$props.render;


                _this.setState(function () {
                  return { isFetching: true };
                });

                if (!(!dataUrl || !render)) {
                  _context.next = 5;
                  break;
                }

                _this.setState(function () {
                  return { isFetching: false, hasError: true };
                });
                return _context.abrupt('return');

              case 5:
                _context.prev = 5;

                // Make Request
                body = method === 'POST' ? JSON.stringify(searchData) : null;
                searchQuery = generateSearchUrlString(searchData);
                url = method === 'POST' ? dataUrl : '' + dataUrl + searchQuery;
                _context.next = 11;
                return fetch(url, {
                  method: method,
                  body: body,
                  headers: { 'Content-Type': 'application/json; charset=utf-8' }
                });

              case 11:
                response = _context.sent;
                _context.next = 14;
                return response.json();

              case 14:
                data = _context.sent;


                _this.setState(function () {
                  return { isFetching: false, data: data };
                });
                _context.next = 22;
                break;

              case 18:
                _context.prev = 18;
                _context.t0 = _context['catch'](5);

                // Catch Error
                _this.setState(function () {
                  return { isFetching: false, hasError: true };
                });
                // eslint-disable-next-line
                console.error('ERROR: ', _context.t0);

              case 22:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2, [[5, 18]]);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }(), _temp), _possibleConstructorReturn(_this, _ret);
  }
  // Set initial state


  _createClass(FetchContent, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.getContent({ sort: this.props.defaultSortOption });
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          isFetching = _state.isFetching,
          hasError = _state.hasError,
          data = _state.data;
      var _props = this.props,
          dataUrl = _props.dataUrl,
          render = _props.render,
          renderLoader = _props.renderLoader;


      if (isFetching && renderLoader) return renderLoader();

      if (isFetching) return React.createElement(
        'p',
        null,
        'Loading...'
      );

      if (!dataUrl || hasError) return React.createElement(
        'p',
        null,
        'There has been a problem fetching data.'
      );

      if (!data) return React.createElement(
        'p',
        null,
        'Sorry, no data could be found.'
      );

      return render({ data: data, refreshContent: this.getContent });
    }
  }]);

  return FetchContent;
}(Component);

FetchContent.propTypes = {
  dataUrl: PropTypes.string.isRequired,
  method: PropTypes.oneOf(['GET', 'POST']),
  renderLoader: PropTypes.func,
  render: PropTypes.func.isRequired,
  defaultSortOption: PropTypes.string
};

FetchContent.defaultProps = {
  method: 'POST',
  renderLoader: null,
  defaultSortOption: null
};

export default FetchContent;